# class Crystal::Macros::MacroExpression

- Crystal::Macros::MacroExpression
- Crystal::Macros::ASTNode

##
Overview

A macro expression.

Every expression node is equivalent to:

    {% if node.output? %}
      \{{ {{ node.exp }} }}
    {% else %}
      \{% {{ node.exp }} %}
    {% end %}

##
Defined in:

compiler/crystal/macros.cr

##
Instance Method Summary

- #exp : ASTNode

  Returns the expression inside this node.

- #output? : BoolLiteral

  Returns whether this node interpolates the expression's result.

### Instance methods inherited from class `Crystal::Macros::ASTNode`

!=(other : ASTNode) : BoolLiteral !=, ==(other : ASTNode) : BoolLiteral ==, class_name : StringLiteral class_name, column_number : StringLiteral | NilLiteral column_number, doc : StringLiteral doc, doc_comment : MacroId doc_comment, end_column_number : StringLiteral | NilLiteral end_column_number, end_line_number : StringLiteral | NilLiteral end_line_number, filename : StringLiteral | NilLiteral filename, id : MacroId id, is_a?(type : TypeNode) : BoolLiteral is_a?, line_number : StringLiteral | NilLiteral line_number, nil? : BoolLiteral nil?, raise(message) : NoReturn raise, stringify : StringLiteral stringify, symbolize : SymbolLiteral symbolize, warning(message : StringLiteral) : NilLiteral warning

##
Instance Method Detail

def exp : ASTNode #

Returns the expression inside this node.

def output? : BoolLiteral #

Returns whether this node interpolates the expression's result.